//
// This help file was automatically generated from assert_condnum.sci using help_from_sci().
// PLEASE DO NOT EDIT
//
mode(1)
//
// Demo of assert_condnum.sci
//

// Show that sin can be ill-conditionned
function [c,y] = sincond (x)
// Condition number of the sin function
y = sin(x)
c = abs(x.*cos(x)) ./ abs(y)
endfunction
[ c , y ] = assert_condnum ( sin , 1.e-100 )         // c~1
[ c , y ] = assert_condnum ( sin , 0 )               // c = nan
[ c , y ] = assert_condnum ( sin , 3.14159 )         // c ~10^6
[ c , y ] = assert_condnum ( sin , 3.141592653 )     // c ~10^9
[ c , y ] = assert_condnum ( sin , 3.1415926535898 ) // c ~10^14
[ c , y ] = assert_condnum ( sin , %pi )             // c ~10^16
[ c , y ] = assert_condnum ( sin , 1.000000357564167061e5 ) // c ~10^16
halt()   // Press return to continue
 
// An ill-conditionned case for the sum.
function [c,y] = sumcond(x)
// Condition number of the sum function
y = sum(x)
c = sum(abs(x)) / abs(y)
endfunction
xl = 10^(1:15);
x = [-xl xl+0.1];
yExpected = 1.5
cExpected = sumcond(x) // c~10^15
[ c , y ] = assert_condnum ( sum , x )
halt()   // Press return to continue
 
// Check various orders for the sqrt function.
function [c,y] = sqrtcond(x)
// Condition number of the sqrt function
y = sum(x)
c = 1/2
endfunction
// The condition number is 0.5.
cc = assert_condnum ( sqrt , 1 , 1 )
cc = assert_condnum ( sqrt , 1 , 2 )
cc = assert_condnum ( sqrt , 1 , 4 )
cc = assert_condnum ( sqrt , 1 , 6 )
// Make a loop
x = 1.;
order = [1 2 4 6];
for k = 1:4
cc = assert_condnum ( sqrt , x , order(k) );
ce = sqrtcond ( x );
d = assert_computedigits(cc,ce);
disp([order(k) cc ce d])
end
halt()   // Press return to continue
 
// Use default order, but configure h
[cc,yc] = assert_condnum ( sqrt , 1 , [] , 1.e-8 )
// Use default order and h
[cc,yc] = assert_condnum ( sqrt , 1 , [] , [] )
// Set order, use default h
[cc,yc] = assert_condnum ( sqrt , 1 , 4 , [] );
halt()   // Press return to continue
 
//========= E N D === O F === D E M O =========//
//
// Load this script into the editor
//
filename = "assert_condnum.sce";
dname = get_absolute_file_path(filename);
editor ( fullfile(dname,filename) );
