//
// This help file was automatically generated from assert_sort.sci using help_from_sci().
// PLEASE DO NOT EDIT
//
mode(1)
//
// Demo of assert_sort.sci
//

// Sort x in increasing order
x = [4 5 1 2 3]
y = assert_sort ( x )
halt()   // Press return to continue
 
// Get the indices
x = [4 5 1 2 3]
[y,indices] = assert_sort ( x )
x(indices)==y
halt()   // Press return to continue
 
// Sort x in decreasing order
x = [4 5 1 2 3];
y = assert_sort ( x , %f )
halt()   // Press return to continue
 
// Use a customized comparison function:
// sort into decreasing order.
function order = myorder ( x , y )
if ( x < y ) then
order = 1
elseif ( x==y ) then
order = 0
else
order = -1
end
endfunction
x = [4 5 1 2 3]
// Notice that we use the default direction (i.e. increasing)
// by setting direction to the empty matrix [].
y = assert_sort ( x , [] , myorder )
halt()   // Press return to continue
 
// Use a customized comparison function:
// sort real values into increasing order,
// with an absolute tolerance.
function order = myrealorder ( x , y , atol )
if ( abs(x-y)<atol ) then
order = 0
elseif ( x < y ) then
order = -1
else
order = 1
end
endfunction
x = [1,2,1.2347,1.2346,1.2345,3,4]
atol = 1.e-3
compfun = list(myrealorder,atol)
y = assert_sort ( x , [] , compfun )
// Notice that the basic comparison function would
// produce a difference sorted matrix.
assert_sort ( x )
// See that this is a stable sort.
// Notice that the equal values are not moved.
y = assert_sort ( x , %f , compfun )
halt()   // Press return to continue
 
// Check that we can sort lists.
// We consider list of elements, where each element
// is a couple. The order depends on the first element (denoted "x"),
// then the second element (denoted "y"), in case of tie.
z = list();
z(1) = list(6,5);
z(2) = list(5,4);
z(3) = list(4,3);
z(4) = list(3,2);
z(5) = list(2,1);
z(6) = list(1,0);
sci2exp(zsorted)
// Use a customized comparison function:
// sort into increasing order.
function order = myorder2 ( a , b )
ax = a(1)
ay = a(2)
bx = b(1)
by = b(2)
if ( ax == bx ) then
if ( ay == by ) then
order = 0
elseif ( ay < by ) then
order = -1
else
order = 1
end
elseif ( ax < bx ) then
order = -1
else
order = 1
end
endfunction
zsorted = assert_sort(z,[],myorder2);
sci2exp(zsorted)
halt()   // Press return to continue
 
// Use a callback to print the status of sorting
function mycb ( status , x , imin , imax )
mprintf("%s: (%d,%d) : %s\n",status,imin,imax,sci2exp(x))
endfunction
// Sort this into [1 2 3 4 5]
x = [4 5 1 2 3];
// Notice that we set compfun = [], so that the default
// comparison function is used.
y = assert_sort ( x , [] , [] , mycb );
halt()   // Press return to continue
 
// Display a graphical demo of the sorting process
function mycb2 ( status , x , imin , imax )
n = length(x)
if ( status == "start") then
h = scf()
xp = 1:n
yp = x
plot(xp,yp,"b*")
titlestr = "Merge sort n="+string(n)+" indices = ("+string(imin)+","+string(imax)+")"
xtitle(titlestr,"Rank","Value")
elseif ( status == "out") then
h = gcf()
h.children.children.children.data(imin:imax,2) = x
titlestr = "Merge sort n="+string(n)+" indices = ("+string(imin)+","+string(imax)+")"
h.children.title.text = titlestr
end
endfunction
N = 50;
// Take the values 1,2,...,50 and permute them randomly
x = (1:50)';
x = grand(1,"prm",x);
y = assert_sort ( x , [] , [] , mycb2 );
halt()   // Press return to continue
 
//========= E N D === O F === D E M O =========//
//
// Load this script into the editor
//
filename = "assert_sort.sce";
dname = get_absolute_file_path(filename);
editor ( fullfile(dname,filename) );
