// Copyright (C) 2010 - DIGITEO - Michael Baudin
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

// <-- JVM NOT MANDATORY -->
// <-- ENGLISH IMPOSED -->

//
// assert_close --
//   Returns 1 if the two real matrices computed and expected are close,
//   i.e. if the relative distance between computed and expected is lesser than epsilon.
// Arguments
//   computed, expected : the two matrices to compare
//   epsilon : a small number
//
function flag = MY_assert_close ( computed, expected, epsilon )
  if (expected==0.0) then
    shift = norm(computed-expected);
  else
    shift = norm(computed-expected)/norm(expected);
  end
  if shift < epsilon then
    flag = 1;
  else
    flag = 0;
  end
  if flag <> 1 then pause,end
endfunction

function flag = MY_assert_equal ( computed , expected )
  if computed==expected then
    flag = 1;
  else
    flag = 0;
  end
  if flag <> 1 then pause,end
endfunction

[c,y] = assert_asincond ( 0.5 );
MY_assert_close ( y , 0.523598775598299 , %eps );
MY_assert_close ( c , 1.10265779084358 , 100*%eps );
//
[c,y] = assert_asincond ( 0 );
MY_assert_equal ( y , 0 );
MY_assert_equal ( c , 1 );
//
[c,y] = assert_asincond ( 1 );
MY_assert_equal ( y , %pi/2 );
MY_assert_equal ( c , %inf );
//
[c,y] = assert_asincond ( -1 );
MY_assert_equal ( y , -%pi/2 );
MY_assert_equal ( c , %inf );

