// Copyright (C) 2010 - DIGITEO - Michael Baudin
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

// <-- JVM NOT MANDATORY -->
// <-- ENGLISH IMPOSED -->

function flag = MY_assert_equal ( computed , expected )
  if computed==expected then
    flag = 1;
  else
    flag = 0;
  end
  if flag <> 1 then pause,end
endfunction

//
// assert_close --
//   Returns 1 if the two real matrices computed and expected are close,
//   i.e. if the relative distance between computed and expected is lesser than epsilon.
// Arguments
//   computed, expected : the two matrices to compare
//   epsilon : a small number
//
function flag = MY_assert_close ( computed, expected, epsilon )
  if (expected==0.0) then
    shift = norm(computed-expected);
  else
    shift = norm(computed-expected)/norm(expected);
  end
  if shift < epsilon then
    flag = 1;
  else
    flag = 0;
  end
  if flag <> 1 then pause,end
endfunction

// A badly conditionned sum
xl = 10^(1:15);
x = [-xl xl+0.1];
[c,y] = assert_sumcond ( x );
MY_assert_close ( y , 1.5 , 1 );
// We can get two answers  : c = 1.3675213675D+15 and c = 1.26984126984126950e+015, 
// depending on the session.
MY_assert_equal ( or(c==[1.367521367521367000D+15 1.26984126984126950e+015] ) , %t );

// A badly conditionned sum, with accurate result !
// The bad conditionning does not imply that the result is not accurate.
xl = 10^(1:15);
x = [-xl xl];
[c,y] = assert_sumcond ( x );
// We can get two answers : sum(x)=0 and sum(x) = 1.75 !!!
// It depends on the Scilab session: guess that this is an effect of the 
// MKL.
MY_assert_equal ( y , 0 );
MY_assert_equal ( c , %inf );

