// Copyright (C) 2010 - DIGITEO - Michael Baudin
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

// <-- JVM NOT MANDATORY -->
// <-- ENGLISH IMPOSED -->

//
// assert_close --
//   Returns 1 if the two real matrices computed and expected are close,
//   i.e. if the relative distance between computed and expected is lesser than epsilon.
// Arguments
//   computed, expected : the two matrices to compare
//   epsilon : a small number
//
function flag = MY_assert_close ( computed, expected, epsilon )
  if (expected==0.0) then
    shift = norm(computed-expected);
  else
    shift = norm(computed-expected)/norm(expected);
  end
  if shift < epsilon then
    flag = 1;
  else
    flag = 0;
  end
  if flag <> 1 then pause,end
endfunction

function flag = MY_assert_equal ( computed , expected )
  if computed==expected then
    flag = 1;
  else
    flag = 0;
  end
  if flag <> 1 then pause,end
endfunction

[c,y] = assert_tancond ( 1 );
MY_assert_close ( y , 1.5574077247 , 1.e-8 );
MY_assert_close ( c , 2.1995003406 , 1.e-8 );
//
[c,y] = assert_tancond ( %pi );
MY_assert_close ( y , -7.81793661990754354001e-17 , 1 );
MY_assert_close ( c , 2.5653050788D+16 , 1.e-8 );
//
[c,y] = assert_tancond ( 0 );
MY_assert_equal ( y , 0 );
MY_assert_equal ( c , 1 );

